# This file was auto-generated by Fern from our API Definition.

import typing

import pydantic
from ..core.pydantic_utilities import IS_PYDANTIC_V2, UniversalBaseModel
from .counterpart_tag_schema import CounterpartTagSchema


class CounterpartOrganizationResponse(UniversalBaseModel):
    email: typing.Optional[str] = pydantic.Field(default=None)
    """
    The email address of the organization
    """

    is_customer: bool = pydantic.Field()
    """
    Indicates if the counterpart is a customer.
    """

    is_vendor: bool = pydantic.Field()
    """
    Indicates if the counterpart is a vendor.
    """

    legal_name: str = pydantic.Field()
    """
    The legal name of the organization.
    """

    phone: typing.Optional[str] = pydantic.Field(default=None)
    """
    The phone number of the organization
    """

    tags: typing.Optional[typing.List[CounterpartTagSchema]] = pydantic.Field(default=None)
    """
    The list of tags for this counterpart.
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
