# This file was auto-generated by Fern from our API Definition.

import typing

import pydantic
from ..core.pydantic_utilities import IS_PYDANTIC_V2, UniversalBaseModel
from .allowed_countries import AllowedCountries
from .vat_rate_component import VatRateComponent


class LineItemProductVatRate(UniversalBaseModel):
    id: typing.Optional[str] = pydantic.Field(default=None)
    """
    Unique identifier of the vat rate object.
    """

    components: typing.Optional[typing.List[VatRateComponent]] = pydantic.Field(default=None)
    """
    Sub-taxes included in the VAT.
    """

    country: AllowedCountries = pydantic.Field()
    """
    Two-letter ISO country code ([ISO 3166-1 alpha-2](https://en.wikipedia.org/wiki/ISO_3166-1_alpha-2)).
    """

    is_custom: typing.Optional[bool] = pydantic.Field(default=None)
    """
    Indicates whether this vat rate is defined by user.
    """

    name: typing.Optional[str] = pydantic.Field(default=None)
    """
    Display name of the vat rate.
    """

    value: int = pydantic.Field()
    """
    Percent minor units. Example: 12.5% is 1250.
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
